const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const membros_equipe = sequelize.define(
    'membros_equipe',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      nome: {
        type: DataTypes.TEXT,
      },

      funcao: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  membros_equipe.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.membros_equipe.hasMany(db.pessoas_atividade, {
      as: 'pessoas_atividade_membro',
      foreignKey: {
        name: 'membroId',
      },
      constraints: false,
    });

    //end loop

    db.membros_equipe.belongsTo(db.equipes_trabalho, {
      as: 'equipe',
      foreignKey: {
        name: 'equipeId',
      },
      constraints: false,
    });

    db.membros_equipe.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.membros_equipe.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.membros_equipe.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return membros_equipe;
};
